# All files / src/stack-trace-analyzer StackTraceAnalyzer.ts

97.44% Statements 38/39
91.67% Branches 11/12
100% Functions 3/3
97.3% Lines 36/37

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    1721x
    1x

    1x

    1x

    1x
    1x

    1x

    1x

    1x

    1x

    1814x

    5283x
    5283x

    5283x

    5283x
    3x

    3x

    5283x

    1824x

    5279x
    5279x
    5279x

    16863x
    16863x
    1x

    16862x

    16862x

    278013x

    267597x

    10416x

    5279x

    10416x
    31248x

    31248x
    27793x

    3455x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../container/ServiceIdentifiers';

    import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { TCalleeDataExtractorsFactory } from '../types/container/TCalleeDataExtractorsFactory';

    import { ICalleeData } from '../interfaces/stack-trace-analyzer/ICalleeData';
    import { ICalleeDataExtractor } from '../interfaces/stack-trace-analyzer/ICalleeDataExtractor';
    import { IStackTraceAnalyzer } from '../interfaces/stack-trace-analyzer/IStackTraceAnalyzer';
    import { IStackTraceData } from '../interfaces/stack-trace-analyzer/IStackTraceData';

    import { CalleeDataExtractors } from '../enums/container/CalleeDataExtractors';

    import { Node } from '../node/Node';
    import { NodeUtils } from '../node/NodeUtils';

    /**
     * This class generates a data with code stack trace functions calls
     *
     * For example:
     *
     * function Foo () {
     *     var baz = function () {
     *
     *     }
     *
     *     baz();
     * }
     *
     * foo();
     *
     * Will generate a structure like:
     *
     * [
     *      {
     *          callee: FOO_FUNCTION_NODE
     *          name: 'Foo',
     *          trace: [
     *              {
     *                  callee: BAZ_FUNCTION_NODE,
     *                  name: 'baz,
     *                  trace: []
     *              }
     *          ]
     *      }
     * ]
     */
    @injectable()
    export class StackTraceAnalyzer implements IStackTraceAnalyzer {
        /**
         * @type {CalleeDataExtractors[]}
         */
        private static readonly calleeDataExtractorsList: CalleeDataExtractors[] = [
            CalleeDataExtractors.FunctionDeclarationCalleeDataExtractor,
            CalleeDataExtractors.FunctionExpressionCalleeDataExtractor,
            CalleeDataExtractors.ObjectExpressionCalleeDataExtractor
        ];

        /**
         * @type {number}
         */
        private static readonly limitThresholdActivationLength: number = 25;

        /**
         * @type {number}
         */
        private static readonly limitThreshold: number = 0.002;

        /**
         * @type {(calleeDataExtractorName: CalleeDataExtractors) => ICalleeDataExtractor}
         */
        private calleeDataExtractorsFactory: (calleeDataExtractorName: CalleeDataExtractors) => ICalleeDataExtractor;

        constructor (
            @inject(ServiceIdentifiers['Factory<ICalleeDataExtractor>']) calleeDataExtractorsFactory: TCalleeDataExtractorsFactory
        ) {
            this.calleeDataExtractorsFactory = calleeDataExtractorsFactory;
        }

        /**
         * @param blockScopeBodyLength
         * @returns {number}
         */
        public static getLimitIndex (blockScopeBodyLength: number): number {
            const lastIndex: number = blockScopeBodyLength - 1;
            const limitThresholdActivationIndex: number = StackTraceAnalyzer.limitThresholdActivationLength - 1;

            let limitIndex: number = lastIndex;

            if (lastIndex > limitThresholdActivationIndex) {
                limitIndex = Math.round(
                    limitThresholdActivationIndex + (lastIndex * StackTraceAnalyzer.limitThreshold)
                );

                Iif (limitIndex > lastIndex) {
                    limitIndex = lastIndex;
                }
            }

            return limitIndex;
        }

        /**
         * @param blockScopeBody
         * @returns {IStackTraceData[]}
         */
        public analyze (blockScopeBody: ESTree.Node[]): IStackTraceData[] {
            return this.analyzeRecursive(blockScopeBody);
        }

        /**
         * @param blockScopeBody
         * @returns {IStackTraceData[]}
         */
        private analyzeRecursive (blockScopeBody: ESTree.Node[]): IStackTraceData[] {
            const limitIndex: number = StackTraceAnalyzer.getLimitIndex(blockScopeBody.length);
            const stackTraceData: IStackTraceData[] = [];
            const blockScopeBodyLength: number = blockScopeBody.length;

            for (let index: number = 0; index < blockScopeBodyLength; index++) {
                if (index > limitIndex) {
                    break;
                }

                const blockScopeBodyNode: ESTree.Node = blockScopeBody[index];

                estraverse.traverse(blockScopeBodyNode, {
                    enter: (node: ESTree.Node): void => {
                        if (
                            !Node.isCallExpressionNode(node) ||
                            blockScopeBodyNode.parentNode !== NodeUtils.getBlockScopesOfNode(node)[0]
                        ) {
                            return;
                        }

                        this.analyzeCallExpressionNode(stackTraceData, blockScopeBody, node);
                    }
                });
            }

            return stackTraceData;
        }

        /**
         * @param stackTraceData
         * @param blockScopeBody
         * @param callExpressionNode
         * @returns {IStackTraceData[]}
         */
        private analyzeCallExpressionNode (
            stackTraceData: IStackTraceData[],
            blockScopeBody: ESTree.Node[],
            callExpressionNode: ESTree.CallExpression
        ): void {
            StackTraceAnalyzer.calleeDataExtractorsList.forEach((calleeDataExtractorName: CalleeDataExtractors) => {
                const calleeData: ICalleeData | null = this.calleeDataExtractorsFactory(calleeDataExtractorName)
                    .extract(blockScopeBody, callExpressionNode.callee);

                if (!calleeData) {
                    return;
                }

                stackTraceData.push({
                    ...calleeData,
                    stackTrace: this.analyzeRecursive(calleeData.callee.body)
                });
            });
        }
    }